#!/usr/bin/perl
# vp 04.08.2009, letzte nderung 14.10.2021

use List::Util qw[min max];

die <<HELP unless @ARGV;
Aufruf: jtc2bin tap-file
konvertiert jtc-tiny-Dateien ins (raw) BIN-Format (ohne Header!)
HELP

open IN, "<$ARGV[0]";
binmode IN;

($OUT = $ARGV[0]) =~ s/\.jtc/\.bin/i;
die "Fehler: keine JTC-Datei!" if $OUT =~ /$ARGV[0]/i;

print "$OUT ";
open OUT, ">$OUT";
binmode OUT;

($INC = $ARGV[0]) =~ s/\.jtc/\.bin.inc/i;
open INC, ">$INC";

# Header lesen
# Kopfblock einlesen und Typ auswerten

# Blocknummer
# block
read IN, $block, 128;

{
	print "MC\n";

	#KC-Header
	($name, $anz, $aadr, $eadr, $sadr) = unpack("
		a16		   # dateiname
		c		   # $anz
		SSS		   # aadr, eadr, sadr: word;	#groes S!
		", $block
	);

	$name =~ s/\x0//g;	# nullbytes
	$name =~ s/ +$//;	# leerzeichen am Ende

	print "name $name, anz $anz, aadr $aadr, eadr $eadr, sadr $sadr\n";
	#printf "%X / %X %X %X %s\n", $anz, $aadr, $eadr, $sadr, $name;

	
	if ($eadr==0) {
		$filelength = -s IN;
		$filelength -= 128;			# Header abziehen
		$eadr = $aadr + $filelength-1;
	}

	$typ = 'M';

	# Basic-Programme beginnen fast immer mit 80 0A
	read IN, $block, 128;
	if (ord(substr($block,0,1)) == 128) { $typ = 'B' }	
	

	#;addFile filename, aadr, [eadr], [sadr], typ, name
	#;Packen - Endung pck ergnzen!
	#addfile "Software/Wolfgang/ANGELN_neu.bin.pck"              , 0E000h, , , 'B', "ANGELN"

	$binfile = $OUT;
	$binfile =~ s|^.*/||;
	#$binfile =. '.pck';

	printf INC qq(	addFile "$binfile", 0%02Xh, 0%02Xh, 0%02Xh, '$typ', "$name" \n), $aadr, $eadr, $sadr;

	#$filelength = $eadr-$aadr;
	# eigentlich
	$filelength = $eadr-$aadr + 1;

	#print "name $name, typ $typ, filelength $filelength\n";

	seek IN, 128, 0;
		
	while ($filelength > 0) {
		read IN, $_, 128;
		#print OUT $_; # wre ok fr 'neue_anwender' 
		syswrite OUT, $_, min($filelength, 128);
		$filelength -= 128;
	}
	close IN;
	close OUT;
	close INC;
}
