#!/usr/bin/perl
# vp 11.10.2021, letzte nderung

$ARGV[0] ||= 'packedrom.bin';    # testweise

die <<HELP unless @ARGV;
Aufruf: showrom.pl rom
zeigt Inhalt des erzeugten ROMs an
HELP

open IN, "<$ARGV[0]";
binmode IN;
print "liste $ARGV[0]...\n";

open OUT, ">$ARGV[0]_inhalt.txt";
$banksize = 0x2000;

# Test auf Kombi-Modul
seek IN, 0, 0;              # auf Fileanfang


print OUT "Nr. EPROM    Bnk+Adr_TINY Typ Name      aadr-eadr,sadr\n\n";

while ( !eof(IN) ) {
  $pos = tell IN;
#  printf "%.4x\n", $pos;
  
  # nchste integrale xx00-Adresse
  read IN, $block, 0x100;

  # Bank und Position in Bank berechnen
  $bank        = int( $pos / $banksize );
  $pos_in_bank = $pos - $bank * $banksize;

  # FA-Kommando
  if ( $block =~ /^\xFA\xFA/ ) {
    #		$name = substr($block,3,8);
    ( $ft_typ, $aadr, $eadr, $sadr, $attrib, $reserve, $typ, $name ) =
      unpack( "
				A2	# db	0FAh, 0FAh	; +0 Kennbytes
				n	# dw	aadr		; +2 Anfangsadresse im RAM
				n	# dw	eadr		; +4 Endadresse im RAM
				n	# dw	sadr		; +6 Startadresse im RAM (oder 0000h - nichtstartend)
				C	# db	Attrib		; +8 Bit7=packed
				A6	# reserviert		; +9 6 Byte Reserve
				A	# db	Dateityp	; +15 genau 1 Zeichen
				A16	# db	'NAME    '	; +16 genau 16 Zeichen
			", $block );

	# print "$aadr, $eadr, $sadr, $typ, $name\n";

    printf OUT "%3d %.8X %.2X %.4X ", ++$nr, $pos, $bank, $pos_in_bank + 0x4000;
    printf OUT "%s %-16s %.4X-%.4X,%.4X\n", $typ, $name, $aadr, $eadr, $sadr;
  }
}

close IN;
close OUT;

